#include "utils.h"
#ifndef __FILTER_H
#define __FILTER_H

#include<deque>

static int FNS = 5;

class Filter
{
  
public:
  long int amissing = 0, afiltered = 0, apassed = 0;
  long int gmissing = 0, gfiltered = 0, gpassed = 0;
  int fid;
  double fp;
  bool noblock = false;
  deque<double> stats;
  string type;
  string name;
  long int missing = 0, filtered = 0, passed = 0;
  double iscand = 0;
  
  virtual void initFilter(string n, string ty, double t, int nstd, string tf, long s, int nl, int r, double mfp);
  virtual int process(string ip, double outtime, int outlen, bool isquery, char* queryname, bool& isattack, int maxreqs, int ttl);
  virtual void reset();
  double getfiltereff();
  virtual void printtable();
  void setnoblock(bool b);
  void resetcounts();
  void getfeff();
  void setpassed(int a, int g);
  
  friend int operator<(Filter f1, Filter f2)
  {
    return f1.fid < f2.fid;
  }
};

#endif
