// This code learns frequent query names 

#include "fq.hh"
#include <vector>

void FQ::updateresolver(long time, char* ip, int req)
{
}

void FQ::processresolver(long time, char* ip, int req)
{
}


double FQ::shouldfilter(char* ip, long int time, bool instant)
{
}

void FQ::setblock(bool b)
{
  block = b;
}

void FQ::loadzone(string infile)
{
  ifstream in(infile, std::ofstream::in);
  string mytld;
  int count;
  while (in.good())
    {
      in>>mytld;
      rootzone.insert(mytld);
    }
}

void FQ::loadtraining(string infile)
{
  ifstream in(infile, std::ofstream::in);
  string type, query, dummy;
  int count;
  while (in.good())
    {
      in>>type>>query>>dummy>>count;
      if (type == "TLD")
	{
	  tld[query] = count;
	  sumtld += count;
	}
      else if (type == "sTLD")
	{
	  stld[query] = count;
	  sumstld += count;
	}
      else if (type == "Full")
	{
	  full[query] = count;
	  sumfull += count;
	}
    }
  if (sumtld == 0)
    sumtld = 1;
  if (sumstld == 0)
    sumstld = 1;
  if (sumfull == 0)
    sumfull = 1;
  in.close();
}

void FQ::insert(map<string, int>& m, string str)
{
  if (m.find(str) == m.end())
    m[str] = 1;
  else
    m[str] ++;
}

void FQ::printtable()
{
}

int FQ::process(string ip, double outtime, int outlen, bool isquery, char* queryname, bool& isattack, int maxreqs, int ttl)
{
  string query;
  query = queryname;
  string myquery = "";
  int index = gettwo(ip.c_str());

  if (isquery)
    {
      myquery = trim(query);
     }
  else
    {
      if (block && resolvers[index].find(ip) != resolvers[index].end())
	{
	  if (isattack)
	    afiltered++;
	  else
	    gfiltered++;
	  filtered = afiltered + gfiltered;
	  return 2;
	}
      else
	{
	  if (isattack)
	    apassed++;
	  else
	    gpassed++;
	  passed = apassed + gpassed;
	  return 0;
	}
    }
  
  if (lasttime == 0)
    lasttime = outtime;
  if (outtime - lasttime > 1)
    {
      samples ++;
      double data = apassed + gpassed;
      double ao = avg;
      avg = avg + (data - avg)/samples;
      ss = ss + (data - ao)*(data - avg);
      
      passed = apassed + gpassed;
      filtered = afiltered + gfiltered;
      missing = amissing + gmissing;

      reqs = 0;
      lasttime = outtime;
    }
  
  if (myquery == "")
    {
      if (block && resolvers[index].find(ip) != resolvers[index].end())
	{
	  if (isattack)
	    afiltered++;
	  else
	    gfiltered++;
	  filtered = afiltered + gfiltered;
	  return 2;
	}
      else
	{
	  if (isattack)
	    apassed++;
	  else
	    gpassed++;
	  passed = apassed + gpassed;
	  return 0;
	}
    }

  string myTLD = "", mysTLD = "", token;
  istringstream sin;
  sin.str(myquery);
  vector<string> names;
  while(std::getline(sin, token, '.')) {
    names.push_back(token);
  }
  if (!names.empty())
    {
      myTLD = names.back();
      names.pop_back();
      if (!names.empty())
	mysTLD = names.back() + "." + myTLD;
    }

  if (starttime < outtime &&  learning > 0)
    {
      learning --;
      learning_done = false;

      if (myTLD != "" && rootzone.find(myTLD) == rootzone.end())
	{
	  insert(ftld, myTLD);
	}
      if (mysTLD != "")
	insert(fstld, mysTLD);

      insert(ffull, myquery);
    }
  else if (!learning_done && outtime > starttime && learning == 0)
    {
      starttime = starttime + 0.1;
      learning = learn;
      learning_done = true;
      frequent_tld.clear();
      frequent_stld.clear();
      frequent_full.clear();
      fp = 0;
      double fptld = 0;
      double fpstld = 0;
      double fpfull = 0;
      double sum = 0;
      for (auto it = ftld.begin(); it != ftld.end(); it++)
	sum += it->second;
      for (auto it = ftld.begin(); it != ftld.end(); it++)
	{
	  double rnow = it->second/sum;
	  double rpre = 0.001;
	  int cpre = 0;
	  if (tld.find(it->first) != tld.end())
	    {
	      rpre = tld[it->first]/sumtld;
	      cpre = tld[it->first];
	    }
	  if (rnow - rpre > THRESH)
	    {
	      frequent_tld.insert(it->first);
	      fptld = fptld + rpre;
	      if (block)
		fptld += 0.01;
	    }
	}
      sum = 0;
      for (auto it = fstld.begin(); it != fstld.end(); it++)
	sum += it->second;
      for (auto it = fstld.begin(); it != fstld.end(); it++)
	{
	  double rnow = it->second/sum;
	  double rpre = 0.001;
	  if (stld.find(it->first) != stld.end())
	    rpre = stld[it->first]/sumstld;
	  if (rnow - rpre > THRESH)
	    {
	      frequent_stld.insert(it->first);
	      fpstld = fpstld + rpre;
	      if (block)
		fpstld += 0.01;
	    }
	}
      sum = 0;
      for (auto it = ffull.begin(); it != ffull.end(); it++)
	sum += it->second;
      for (auto it = ffull.begin(); it != ffull.end(); it++)
	{
	  double rnow = it->second/sum;
	  double rpre = 0.001;
	  if (full.find(it->first) != full.end())
	    rpre = full[it->first]/sumfull;
	  if (rnow - rpre > THRESH)
	    {
	      frequent_full.insert(it->first);
	      fpfull = fpfull + rpre;
	      if (block)
		fpfull += 0.01;
	    }
	}
      ftld.clear();
      fstld.clear();
      ffull.clear();
      fp = fptld;
      // Keep only the longest match
      if (!frequent_full.empty())
	{
	  frequent_stld.clear();
	  frequent_tld.clear();
	  fp = fpfull;
	}
      else if (!frequent_stld.empty())
	{
	  frequent_tld.clear();
	  fp = fpstld;
	}

    }
  // Here check if on frequent list and filter
  if (frequent_tld.find(myTLD) != frequent_tld.end() ||
      frequent_stld.find(mysTLD) != frequent_stld.end() ||
      frequent_full.find(myquery) != frequent_full.end() ||
      (block && resolvers[index].find(ip) != resolvers[index].end()))
    {
      if (resolvers[index].find(ip) == resolvers[index].end())
	resolvers[index][ip] = true;
      if (isattack)
	afiltered++;
      else
	gfiltered++;
      filtered = afiltered + gfiltered;
      return 2;
    }
  else
    {
      if (isattack)
	apassed++;
      else
	gpassed++;
      passed = apassed + gpassed;
      return 0;
    }
}

void FQ::setlearn(int m)
{
  learn = m;
}

void FQ::initFilter(string n, string ty, double t, int nstd, string tf, long s, int nl, int r, double mfp) 
{
  loadzone("rootzone");
  name = n;
  delimiters = (int*) malloc(AR_LEN*sizeof(int));
  starttime = s;
  RUN = r;
  THRESH = t;
  infile = tf;
  type = ty;
  fp = mfp;

  loadtraining(infile);
}

  

