#include "utils.h"
#include "filter.hh"

#ifndef __FQ_H
#define __FQ_H

class FQ:public Filter
{
  long int lasttime = 0;
  int nlimits = 9;
  int samples = 0;
  double avg = 0;
  double ss = 0;

  bool noblock = false;

  int RUN = 3600;
  int BLOCK = 60;
  int reqs = 0;
  string readfolder = "";
  string infile = "";
  string atfile = "";
  string extension = "";
  long starttime;
  int mode;

  map<string,int> tld;
  map<string,int> stld;
  map<string,int> full;
  set<string> rootzone;
  
  map<string,int> ftld;
  map<string,int> fstld;
  map<string,int> ffull;


  set <string> frequent_tld;
  set <string> frequent_stld;
  set <string> frequent_full;
  

  int learn = 0;
  bool block = false;
  int learning = 0;
  int sumtld = 0, sumstld = 0, sumfull = 0;
  double THRESH = 0;
  
  // We store delimiters in this array
  int* delimiters;
  map<string,bool> resolvers[NR];
  
  void insert(map<string, int>& m, string str);
  void updateresolver(long time, char* ip, int req);
  void processresolver(long time, char* ip, int req);
  void remember(string srcc, int ttl);
  
  double shouldfilter(char* ip, long int time, bool instant);
  void loadattackers(string infile);
  void loadtraining(string infile);
  void loadzone(string infile);
  bool learning_done = false;
  
public:
  void setblock(bool);
  void setlearn(int l);
  void printtable() override;
  void initFilter(string n, string ty, double t, int nstd, string tf, long s, int nl, int r, double mfp) override;
  int process(string ip, double outtime, int outlen, bool isquery, char* queryname, bool& isattack, int maxreqs, int ttl) override;
};

#endif
