// This code learns packet rate per source IP per several time windows
// only for traffic going to port 53

#include "hcf.hh"

// We'll hardcode how to correct for spurious spoofing that changes
// who is attacker and who is legitimate. To apply this correction
// for 20151130 dataset set CORRECT to 1
#define CORRECT 0

void HCF::updateresolver(long time, char* ip, int req)
{
}

void HCF::processresolver(long time, char* ip, int req)
{
}


void HCF::remember(string srcc, int ttl)
{
  if (resolvers.find(srcc) == resolvers.end())
    {
      map<int,int> m;
      resolvers[srcc] = m;
    }
  if (resolvers[srcc].find(ttl) == resolvers[srcc].end())
    resolvers[srcc][ttl] = 0;
  resolvers[srcc][ttl]++;
}

double HCF::shouldfilter(char* ip, long int time, bool instant)
{
}
   
void HCF::loadtraining(string infile)
{
  ifstream in(infile, std::ofstream::in);
  string src;
  int ttl;
  while (in.good())
    {
      in>>src>>ttl;
      remember(src.c_str(),ttl);
    }
  in.close();
}

void HCF::loadcorrection(string infile)
{
  ifstream in(infile, std::ofstream::in);
  string src;
  while (in.good())
    {
      in>>src;
      correction.insert(src);
      cout<<"Inserted correction "<<src<<endl;
    }
  in.close();
}

int HCF::process(string ip, double outtime, int outlen, bool isquery, char* queryname, bool& isattack, int maxreqs, int ttl)
{
  if (lasttime == 0)
    lasttime = outtime;
  if (outtime - lasttime > 1)
    {
      samples ++;
      double data = apassed + gpassed;
      
      double ao = avg;
      avg = avg + (data - avg)/samples;
      ss = ss + (data - ao)*(data - avg);
      
      passed = apassed + gpassed + amissing + gmissing;
      filtered = afiltered + gfiltered;
      missing = amissing + gmissing;
      
      reqs = 0;
      lasttime = outtime;
    }
  
  char* ips = ip.c_str();
  int index = gettwo(ips);
  if (ip == "")
    return 1;

  // Resolver is missing in training, don't do anything
  if (resolvers.find(ip) == resolvers.end())
    {
      if (isattack)
	{
	  if (mode == 1)
	    {
	      amissing++;
	      passed = apassed + gpassed + amissing + gmissing;
	    }
	  else
	    {
	      afiltered++;
	      filtered = afiltered + gfiltered;
	    }
	}
      else
	{
	  if (mode == 1)
	    {
	      if (CORRECT && correction.find(ip) != correction.end() && outtime >= 1448866524 && outtime <= 1448866527)
		{
		  isattack = true;
		  amissing++;
		}
	      else
		gmissing++;
	      passed = apassed + gpassed + amissing + gmissing;
	      if (outtime >= 1448866524 && outtime <= 1448866527)
		cout<<outtime<<" "<<ip<<" filtered, ttl "<<ttl<<" correct "<<CORRECT<<" in correction "<<(correction.find(ip) != correction.end())<<" missing "<<afiltered<<" "<<gfiltered<<endl; 
	    }
	  else
	    {
	      if (CORRECT && correction.find(ip) != correction.end() && outtime >= 1448866524 && outtime <= 1448866527)
		{
		  isattack = true;
		  afiltered++;
		}
	      else
		gfiltered++;
	      filtered = afiltered + gfiltered;
	      if (outtime >= 1448866524 && outtime <= 1448866527)
		cout<<outtime<<" "<<ip<<" filtered, ttl "<<ttl<<" correct "<<CORRECT<<" in correction "<<(correction.find(ip) != correction.end())<<" not found "<<afiltered<<" "<<gfiltered<<endl;
	    }
	}
 
     // Is mode 1 = hcf or 2 = unknown res. filter or 
      if (mode == 1)
	return 0;
      else
	return 2;
    }
  // Is mode 1 = hcf or 2 = unknown res. filter or 
  if (mode == 2)
    {
      if (isattack)
	apassed++;
      else
	gpassed++;
      passed = apassed + gpassed;
      return 0;
    }
  else
    {
      if (resolvers[ip].find(ttl) == resolvers[ip].end())
	{
	  if (isattack)
	    afiltered++;
	  else
	    {
	      if (CORRECT && correction.find(ip) != correction.end() && outtime >= 1448866524 && outtime <= 1448866527)
		{
		  isattack = true;
		  afiltered++;
		}
	      else
		gfiltered++;
	      if (outtime >= 1448866524 && outtime <= 1448866527)
		cout<<outtime<<" "<<ip<<" filtered, ttl "<<ttl<<" correct "<<CORRECT<<" in correction "<<(correction.find(ip) != correction.end())<<" not found "<<afiltered<<" "<<gfiltered<<endl;
	    }
	  filtered = afiltered + gfiltered;
	  return 2;
	}
      else 
	{
	  if (isattack)
	    apassed++;
	  else
	    gpassed++;
	  passed = apassed + gpassed + amissing + gmissing;
	  return 0;
	}
    }
}

void HCF::setmode(int m)
{
  mode = m;
}

void HCF::initFilter(string n, string ty, double t, int nstd, string tf, long s, int nl, int r, double mfp) 
{
  delimiters = (int*) malloc(AR_LEN*sizeof(int));
  starttime = s;
  RUN = r;
  infile = tf;
  name = n;
  type = ty;
  fp = mfp;
  loadtraining(infile);
  if (CORRECT)
    loadcorrection("201511.correct");
}

  

