#include "utils.h"
#include "filter.hh"

#ifndef __HCF_H
#define __HCF_H

class HCF:public Filter
{
  
  long int lasttime = 0;
  int nlimits = 9;
  int samples = 0;
  double avg = 0;
  double ss = 0;

  bool noblock = false;

  int RUN = 3600;
  int BLOCK = 60;
  int reqs = 0;
  string readfolder = "";
  string infile = "";
  string atfile = "";
  string extension = "";
  long starttime;
  int mode;
  map<string,map<int,int>> resolvers;
  set<string> correction;

  // We store delimiters in this array
  int* delimiters;

  void updateresolver(long time, char* ip, int req);
  void processresolver(long time, char* ip, int req);
  void remember(string srcc, int ttl);
  
  double shouldfilter(char* ip, long int time, bool instant);
  void loadattackers(string infile);
  void loadtraining(string infile);
  void loadcorrection(string infile);
  
public:
  void setmode(int m);
  void initFilter(string n, string ty, double t, int nstd, string tf, long s, int nl, int r, double mfp) override;
  int process(string ip, double outtime, int outlen, bool isquery, char* queryname, bool& isattack, int maxreqs, int ttl) override;
};

#endif
