#include "utils.h"
#include "filter.hh"

#ifndef __WILD_H
#define __WILD_H

class Wild:public Filter
{
  int NUMSTDM=5;
  
  long int lasttime = 0;
  double threshPts;
  int nlimits = 9;
  int samples = 0;
  double avg = 0;
  double ss = 0;
  double cusum = 0;


  int RUN = 3600;
  int BLOCK = 60;
  int reqs = 0;
  string readfolder = "";
  string infile = "";
  string atfile = "";
  string extension = "";
  int limits[9]={1,2,4,8,16,32,64,128,256};
  long starttime;

  map<string,record> resolvers[NR];

  // We store delimiters in this array
  int* delimiters;

  void updateresolver(long time, char* ip, int req);
  void processresolver(long time, char* ip, int req);

  double shouldfilter(char* ip, long int time, bool instant);
  void loadattackers(string infile);
  void loadtraining(string infile);
public:
  void initFilter(string n, string ty, double t, int nstd, string tf, long s, int nl, int r, double mfp) override;
  int process(string ip, double outtime, int outlen, bool isquery, char* queryname, bool& isattack, int maxreqs, int ttl) override;
  void reset() override;
};

#endif
